--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*1, g = playerColor.g*1,b = playerColor.b*1,a = 1}
local InkedBackDropNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		tile = true,
		tileEdge = true,
		tileSize = 8,
		edgeSize = 1,
		insets = { left = 0, right = 0, top = 0, bottom =0 },
		
	}



local DurabilityMover = CreateFrame("Frame","InkedDurabilityBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	DurabilityMover:SetSize(350,24)
	DurabilityMover:SetFrameLevel(98)
	DurabilityMover:SetClampedToScreen(true)
	DurabilityMover:SetClampRectInsets(0, 0, 0,0)
	
	local DurabilityMoverText  = DurabilityMover:CreateFontString(nil, "OVERLAY")
	DurabilityMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	DurabilityMoverText:SetPoint("CENTER",DurabilityMover,"CENTER", 0,0); 
	DurabilityMoverText:SetText("")
	
	local InkedDurabilityBar = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedDurabilityBar:SetAllPoints(DurabilityMover)
	
	local Durabilityframe = CreateFrame("Frame", nil, InkedDurabilityBar, BackdropTemplateMixin and "BackdropTemplate")
	Durabilityframe:SetAllPoints(InkedDurabilityBar)
	Durabilityframe:EnableMouse(true)
	
	Durabilityframe.bar = CreateFrame("StatusBar", nil, Durabilityframe, BackdropTemplateMixin and "BackdropTemplate")
	Durabilityframe.bar:SetPoint("TOPLEFT",2, -2)
	Durabilityframe.bar:SetFrameLevel(6)
	
	local DurabilityText = Durabilityframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			DurabilityText:SetPoint("LEFT", 2, 0)
			DurabilityText:SetJustifyH("CENTER")
			DurabilityText:SetJustifyV("CENTER")
			DurabilityText:SetText("Durability: ")

	local DurabilityCurrentText = Durabilityframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			DurabilityCurrentText:SetPoint("RIGHT", -2, 0)
			DurabilityCurrentText:SetJustifyH("LEFT")
			DurabilityCurrentText:SetJustifyV("CENTER")
			
			
			
local localSlots = {
		[1] = {1, INVTYPE_HEAD, 1000},
		[2] = {3, INVTYPE_SHOULDER, 1000},
		[3] = {5, INVTYPE_CHEST, 1000},
		[4] = {6, INVTYPE_WAIST, 1000},
		[5] = {9, INVTYPE_WRIST, 1000},
		[6] = {10, INVTYPE_HAND, 1000},
		[7] = {7, INVTYPE_LEGS, 1000},
		[8] = {8, INVTYPE_FEET, 1000},
		[9] = {16, INVTYPE_WEAPONMAINHAND, 1000},
		[10] = {17, INVTYPE_WEAPONOFFHAND, 1000},
		[11] = {18, INVTYPE_RANGED, 1000}
	}
	
	local Total = 0
	local current, max
	
	local function gradientColor(perc)
		perc = perc > 1 and 1 or perc < 0 and 0 or perc -- Stay between 0-1
		local seg, relperc = math.modf(perc*2)
		local r1, g1, b1, r2, g2, b2 = select(seg*3+1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0) -- R -> Y -> G
		local r, g, b = r1+(r2-r1)*relperc, g1+(g2-g1)*relperc, b1+(b2-b1)*relperc
		return format("|cff%02x%02x%02x", r*255, g*255, b*255), r, g, b
	end
	for i = 1, 11 do
			if GetInventoryItemLink("player", localSlots[i][1]) ~= nil then
				current, max = GetInventoryItemDurability(localSlots[i][1])
				if current then
					localSlots[i][3] = current/max
					Total = Total + 1
				end
			end
		end
		table.sort(localSlots, function(a, b) return a[3] < b[3] end)
	
	local dcolor = gradientColor(math.floor(localSlots[1][3]*100)/100)
	local function OnEvent(self)
	
		for i = 1, 11 do
			if GetInventoryItemLink("player", localSlots[i][1]) ~= nil then
				current, max = GetInventoryItemDurability(localSlots[i][1])
				if current then
					localSlots[i][3] = current/max
					Total = Total + 1
				end
			end
		end
		table.sort(localSlots, function(a, b) return a[3] < b[3] end)
		
		if Total > 0 then
			local dcolor = gradientColor(math.floor(localSlots[1][3]*100)/100)
			
				DurabilityCurrentText:SetText(math.floor(localSlots[1][3]*100).." |r%")
				Durabilityframe.bar:SetMinMaxValues(0, 100)
				Durabilityframe.bar:SetValue(math.floor(localSlots[1][3]*100))
						
		end
		
		self:SetScript("OnEnter", function()
		
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()

			for i = 1, 11 do
				if localSlots[i][3] ~= 1000 then
					green = localSlots[i][3]*2
					red = 1 - green
					GameTooltip:AddDoubleLine(localSlots[i][2], floor(localSlots[i][3]*100).."%", 1, 1, 1, red+1, green,0)
				end
			end

			
			GameTooltip:Show()
		end)
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		Total = 0
	end

	Durabilityframe:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
	Durabilityframe:RegisterEvent("MERCHANT_SHOW")
	Durabilityframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	Durabilityframe:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" then
			
			self:GetScript("OnEnter")(self)
		else
			ToggleCharacter("PaperDollFrame")
		end
	end)
	Durabilityframe:SetScript("OnEvent", OnEvent)			
			
			

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.DuraEnable == true then 
			local point, relativeTo, relativePoint, xOfs, yOfs = DurabilityMover:GetPoint(n)
			Inked.db.profile.DuraX = xOfs
			Inked.db.profile.DuraY = yOfs
			Inked.db.profile.DuraPoint = point
			DurabilityMoverText:SetText("Durability Bar")
		end
	end	
			DurabilityMover:SetSize(Inked.db.profile.DuraWidth,Inked.db.profile.DuraHeight)
			Durabilityframe.bar:SetSize(Inked.db.profile.DuraWidth-4,Inked.db.profile.DuraHeight-5)
			
			DurabilityText:SetFont(LSM:Fetch("font", Inked.db.profile.Durafont), Inked.db.profile.DuraFontSize, Inked.db.profile.DuraFontOutline)
			DurabilityCurrentText:SetFont(LSM:Fetch("font", Inked.db.profile.Durafont), Inked.db.profile.DuraFontSize, Inked.db.profile.DuraFontOutline)
			Durabilityframe.bar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.DuraStatusBar))
			local DuraMath = math.floor(localSlots[1][3]*100)
			if DuraMath < 30 then
				Durabilityframe.bar:SetStatusBarColor(1,0,0,0.75)
			end
			if DuraMath > 30 then
				Durabilityframe.bar:SetStatusBarColor(1,1,0,0.75)
			end
			if DuraMath > 70 then
				Durabilityframe.bar:SetStatusBarColor(0,1,0,0.75)
			end
			

end
			
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)
	
local function CreateButtonTexture(frame)
	local ButtonForground = CreateFrame("Frame","Foreground",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForground:SetAllPoints(frame)
		  ButtonForground:SetFrameLevel(4)
	local ButtonTexture = ButtonForground:CreateTexture(nil, "BACKGROUND")
		  ButtonTexture:SetAllPoints()
		  ButtonTexture:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		  ButtonTexture:SetTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\PsychoButton")

end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end


local function SetDurabilityBar()

		Durabilityframe.bar:SetBackdrop(InkedBackDropNFO)
		Durabilityframe.bar:SetBackdropColor(0.7,0.3,0.3,1)
		Durabilityframe.bar:SetBackdropBorderColor(0.7,0.3,0.3,1)

	if(Inked.db.profile.lockframes == false) then
			DurabilityMover:ClearAllPoints()
			if Inked.db.profile.DuraPoint == nil then
				DurabilityMover:SetPoint("TOP", UIParent,Inked.db.profile.DuraX,Inked.db.profile.DuraY)
			else
				DurabilityMover:SetPoint(Inked.db.profile.DuraPoint, UIParent,Inked.db.profile.DuraX,Inked.db.profile.DuraY)
			end
			DurabilityMover:SetBackdrop(InkedBackDropNFO) 
			DurabilityMover:SetBackdropColor(0,0.55,0.95,0.45)
			DurabilityMover:SetBackdropBorderColor(0,0.55,0.95,0)
			DurabilityMover:SetMovable(true)
			DurabilityMover:EnableMouse(true)
			DurabilityMover:RegisterForDrag("LeftButton")
			DurabilityMover:SetScript("OnDragStart", DurabilityMover.StartMoving)
			DurabilityMover:SetScript("OnDragStop", DurabilityMover.StopMovingOrSizing)
			DurabilityMover:SetUserPlaced(true)
		elseif Inked.db.profile.DuraPoint == nil then
				DurabilityMover:SetPoint("TOP", UIParent,Inked.db.profile.DuraX,Inked.db.profile.DuraY)
			else
				DurabilityMover:SetPoint(Inked.db.profile.DuraPoint, UIParent,Inked.db.profile.DuraX,Inked.db.profile.DuraY)
		end
end


local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
		--InkedREPBar:Show()
		--print("walking")
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
		--InkedREPBar:Hide()
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
	if(inBattle == true) then	
		InkedDurabilityBar:Hide()
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
		InkedDurabilityBar:Show()		
	end
end
local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
		InkedLoginFrame:RegisterEvent("MERCHANT_SHOW")
		InkedLoginFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
		if Inked.db.profile.UseActionBars == false then return end
		if Inked.db.profile.DuraEnable == false then return end
			SetDurabilityBar()
			StartBattlePetsFun()
			EndBattlePetsFun()
			ridingFun()
			walkingFun()												
		end)
		
